# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           aries-jmx
Summary:        Apache Aries JMX component
Url:            http://aries.apache.org
Version:        0.3
Release:        1%{?dist}
Epoch:          0
License:        Apache 2.0 License
Group:          Development/Libraries
Source0:        http://www.apache.org/dist//aries/jmx-0.3-source-release.zip

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Patch0:         aries-jmx-bootstrap-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  ant-contrib
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  mojo-maven2-plugin-findbugs
BuildRequires:  mojo-maven2-plugin-properties
BuildRequires:  jmock2
BuildRequires:  ops4j-pax-exam
BuildRequires:  aries-parent
BuildRequires:  aries-testsupport

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  aries-parent

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
Apache Aries JMX component.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n jmx-%{version}
chmod -R go=u-w *
cp %{SOURCE1} settings.xml
%patch0 -b .sav0

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        -DobrRepository=NONE \
        install javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/aries
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.apache.aries.jmx jmx %{version} JPP/aries jmx
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.aries-jmx.pom

%add_to_maven_depmap org.apache.aries.jmx org.apache.aries.jmx.api %{version} JPP/aries org.apache.aries.jmx.api
install -m 644 jmx-api/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.aries-org.apache.aries.jmx.api.pom
install -m 644 jmx-api/target/org.apache.aries.jmx.api-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/aries

%add_to_maven_depmap org.apache.aries.jmx org.apache.aries.jmx.blueprint.api %{version} JPP/aries org.apache.aries.jmx.blueprint.api
install -m 644 jmx-blueprint-api/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.aries-org.apache.aries.jmx.blueprint.api.pom
install -m 644 jmx-blueprint-api/target/org.apache.aries.jmx.blueprint.api-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/aries

%add_to_maven_depmap org.apache.aries.jmx org.apache.aries.jmx.blueprint %{version} JPP/aries org.apache.aries.jmx.blueprint
install -m 644 jmx-blueprint-bundle/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.aries-org.apache.aries.jmx.blueprint.pom
install -m 644 jmx-blueprint-bundle/target/org.apache.aries.jmx.blueprint-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/aries

%add_to_maven_depmap org.apache.aries.jmx org.apache.aries.jmx.blueprint.core %{version} JPP/aries org.apache.aries.jmx.blueprint.core
install -m 644 jmx-blueprint-core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.aries-org.apache.aries.jmx.blueprint.core.pom
install -m 644 jmx-blueprint-core/target/org.apache.aries.jmx.blueprint.core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/aries

%add_to_maven_depmap org.apache.aries.jmx org.apache.aries.jmx %{version} JPP/aries org.apache.aries.jmx
install -m 644 jmx-bundle/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.aries-org.apache.aries.jmx.pom
install -m 644 jmx-bundle/target/org.apache.aries.jmx-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/aries

%add_to_maven_depmap org.apache.aries.jmx org.apache.aries.jmx.core %{version} JPP/aries org.apache.aries.jmx.core
install -m 644 jmx-core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.aries-org.apache.aries.jmx.core.pom
install -m 644 jmx-core/target/org.apache.aries.jmx.core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/aries

%add_to_maven_depmap org.apache.aries.jmx org.apache.aries.jmx.whiteboard %{version} JPP/aries org.apache.aries.jmx.whiteboard
install -m 644 jmx-whiteboard/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.aries-org.apache.aries.jmx.whiteboard.pom
install -m 644 jmx-whiteboard/target/org.apache.aries.jmx.whiteboard-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/aries

(cd $RPM_BUILD_ROOT%{_javadir}/aries && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%{_javadir}/aries/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Tue Feb 12 2013 Ralph Apel <r.apel at r-apel.de> 0:0.3-1
- First release
